unit MAIN_32;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,IniFiles,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Spin, Grids,
  port_32;

type
  TMainForm = class(TForm)
    GroupBox2: TGroupBox;
    B_Read: TButton;
    B_ReadAll: TButton;
    B_Write: TButton;
    B_WriteAll: TButton;
    BitBtn3: TBitBtn;
    B_Open: TButton;
    GRead: TStringGrid;
    GWrite: TStringGrid;
    C_Hard: TCheckBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    B_Exchange: TButton;
    GExchange: TStringGrid;
    HwCtrl: TVicPort32;
    procedure B_OpenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure GReadSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure B_WriteClick(Sender: TObject);
    procedure B_WriteAllClick(Sender: TObject);
    procedure B_ReadClick(Sender: TObject);
    procedure B_ReadAllClick(Sender: TObject);
    procedure C_HardClick(Sender: TObject);
    procedure B_ExchangeClick(Sender: TObject);
  end;

const MaxPorts = 16;

var
  MainForm: TMainForm;
  PortWSel,PortRSel:Word;
  ValWSel:Byte;
  NomWSel,NomRSel:Byte;

implementation

{$R *.DFM}

procedure ShowButtons;
begin
  with MainForm,HwCtrl do
  begin
   if ActiveHW then B_Open.caption:='Close Driver'
               else B_Open.caption:='Open Driver';
   B_Write.Enabled:=ActiveHW;
   B_Exchange.Enabled:=ActiveHW;
   B_Read.Enabled:=ActiveHW;
   B_WriteAll.Enabled:=ActiveHW;
   B_ReadAll.Enabled:=ActiveHW;
  end;
end;

procedure TMainForm.B_OpenClick(Sender: TObject);
begin
  if HwCtrl.ActiveHW then begin HwCtrl.CloseDriver; end
  else begin
         HwCtrl.OpenDriver;
         if not HwCtrl.ActiveHW then
         begin
           MessageBeep(0);
           Application.MessageBox('Driver "VICPRTxx" not found',
                      ' Warning! ',mb_OK or mb_ICONHAND);
         end;
       end;
  ShowButtons;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  HwCtrl.CloseDriver;
  ShowButtons;
end;

procedure TMainForm.FormActivate(Sender: TObject);
var MyIniFile : TIniFile;
    i         : Word;
begin

 if GetVersion<0 then Label5.caption:='Detected: Windows 95'
                 else Label5.caption:='Detected: Windows NT';

 MyInifile:=TIniFile.Create('HW_test.ini');

 with MyIniFile,HWCtrl do
 begin
  for i:=1 to MaxPorts do
  begin
    with GWrite do
    begin
      Cells[0,i]:=IntToStr(i);
      Cells[1,0]:='PORT'; Cells[2,0]:='VAL';
      Cells[1,i]:=ReadString('PortW','Port'+IntToStr(i),'');
      Cells[2,i]:=ReadString('Values','Val'+IntToStr(i),'');
    end;
    with GRead do
    begin
      Cells[0,i]:=IntToStr(i);
      Cells[1,0]:='PORT'; Cells[2,0]:='VAL';
      Cells[1,i]:=ReadString('PortR','Port'+IntToStr(i),'');
    end;
    with GExchange do
    begin
      Cells[0,i]:=IntToStr(i);
      Cells[1,0]:='PORT'; Cells[2,0]:='VAL';Cells[3,0]:='W';
      Cells[1,i]:=ReadString('PortE','Port'+IntToStr(i),'');
      Cells[2,i]:=ReadString('PortE','Val'+IntToStr(i),'');
      Cells[3,i]:=IntToStr(Byte(ReadBool('PortE','Write'+IntToStr(i),FALSE)));
    end;

  end;
  C_Hard.Checked:=HardAccess;
 end;
 MyIniFile.Free;
 ShowButtons;
end;

procedure TMainForm.BitBtn3Click(Sender: TObject);
var MyIniFile : TIniFile;
    i         : Word;
begin
 MyInifile:=TIniFile.Create('HW_test.ini');
 with MyIniFile,HWCtrl  do
 begin
  for i:=1 to MaxPorts do
  begin
    with GWrite do
    begin
      WriteString('PortW','Port'+IntToStr(i),Cells[1,i]);
      WriteString('Values','Val'+IntToStr(i),Cells[2,i]);
    end;
    with GRead do
    begin
      WriteString('PortR','Port'+IntToStr(i),Cells[1,i]);
    end;
    with GExchange do
    begin
      WriteString('PortE','Port' +IntToStr(i),Cells[1,i]);
      WriteString('PortE','Val'  +IntToStr(i),Cells[2,i]);
      WriteBool  ('PortE','Write'+IntToStr(i),Boolean(StrToInt(Cells[3,i])));
    end;

  end;
 end;
 MyIniFile.Free;
 Close;
end;

function HexToInt(s:String):dWord;
const hexch:array[0..15] of Char='0123456789ABCDEF';
var i,j : Byte;
    r,n,k:dWord;
    ch : Char;
begin
  k:=1; r:=0;
  for i:=Length(s) downto 1 do
  begin
    ch:=s[i]; n:=0;
    for j:=0 to 15 do if UpperCase(ch)=hexch[j] then n:=j;
    r:=r+n*k; if i>1 then k:=k*16;
  end;
  Result:=r;
end;

procedure TMainForm.GReadSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  with GRead do
  begin
    PortRSel:=HexToInt(Cells[1,Row]); NomRSel:=Row;
  end;
end;

procedure TMainForm.B_WriteClick(Sender: TObject);
begin
 with GWrite,HwCtrl do
 begin
   PortWSel:=HexToInt(Cells[1,Row]);    Cells[1,Row]:=IntToHex(PortWSel,4);
   ValWSel:=HexToInt(Cells[2,Row]);     Cells[2,Row]:=IntToHex(ValWSel,2);
   NomWSel:=Row;
   if (PortWSel=0) then begin MessageBeep(0); Exit; end;
   Port[PortWSel]    :=ValWSel;
 end;
end;
procedure TMainForm.B_WriteAllClick(Sender: TObject);
var i,v       : Byte;
    P,N       : Word;
    values    : array[1..16] of Byte;
    ports     : array[1..16] of Word;
begin
 with GWrite,HwCtrl do
 begin
   N:=0;
   for i:=1 to MaxPorts do
   begin
     P:=HexToInt(Cells[1,i]); Cells[1,i]:=IntToHex(P,4);
     if p>0 then
     begin
       V:=HexToInt(Cells[2,i]); Cells[2,i]:=IntToHex(v,2);
       Inc(N); values[N]:=V; ports[N]:=P;
       Port[P]:=V;
     end;
   end;
 end;
end;

procedure TMainForm.B_ReadClick(Sender: TObject);
var b : Byte;
begin
 with GRead,HwCtrl do
 begin
   PortRSel:=HexToInt(Cells[1,Row]); Cells[1,Row]:=IntToHex(PortRSel,4);
   NomRSel:=Row;
   if (PortRSel=0) then begin MessageBeep(0); Exit; end;
   b:=Port[PortRSel];
   Cells[2,Row]:=IntToHex(b,2);
 end;
end;

procedure TMainForm.B_ReadAllClick(Sender: TObject);
var i,b       : Byte;
    P,N       : Word;
    values,cl : array[1..16] of Byte;
    ports     : array[1..16] of Word;
    V : Byte;
begin
 with GRead,HwCtrl do
 begin
   N:=0;
   for i:=1 to MaxPorts do
   begin
     P:=HexToInt(Cells[1,i]); Cells[1,i]:=IntToHex(P,4);
     if p>0 then
     begin
       Inc(N); ports[N]:=P; cl[N]:=i; values[N]:=V;
     end;
   end;
   for i:=1 to N do
   begin
     b:=Port[ports[i]];
     Cells[2,cl[i]]:=IntToHex(b,2);
   end;
 end;
end;

procedure TMainForm.C_HardClick(Sender: TObject);
begin
  HwCtrl.HardAccess:=C_Hard.Checked;
end;

procedure TMainForm.B_ExchangeClick(Sender: TObject);
var RecRec    : array[1..16] of TPortRecord;
    i,b       : Byte;
    P,N       : Word;
    cl        : array[1..16] of Byte;
begin
 with GExchange,HwCtrl do
 begin
   N:=0;
   for i:=1 to MaxPorts do
   begin
     P:=HexToInt(Cells[1,i]); Cells[1,i]:=IntToHex(P,4);
     if p>0 then
     begin
       Inc(N);
       RecRec[N].nPort:=P;
       RecRec[N].Data:=HexToInt(Cells[2,i]);
       RecRec[N].fWrite:=Cells[3,i]='1';
       cl[N]:=i;
     end;
   end;
   PortExchange(@RecRec,N);
   for i:=1 to N do Cells[2,cl[i]]:=IntToHex(RecRec[i].Data,2);
 end;

end;

initialization
  NomWSel:=0; NomRSel:=0;
end.
